## gudhi 3.9.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)

project(GUDHIdev)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/src/cmake/modules/")
include(CMakeGUDHIVersion.txt)
include(GUDHI_options)

# Reset cache
set(GUDHI_MODULES "" CACHE INTERNAL "GUDHI_MODULES")
set(GUDHI_MISSING_MODULES "" CACHE INTERNAL "GUDHI_MISSING_MODULES")

# This variable is used by Cython CMakeLists.txt and by GUDHI_third_party_libraries to know its path
set(GUDHI_PYTHON_PATH "src/python")

include(GUDHI_submodules)

if (WITH_GUDHI_THIRD_PARTY)
  # For third parties libraries management - To be done last as CGAL updates CMAKE_MODULE_PATH
  include(GUDHI_third_party_libraries NO_POLICY_SCOPE)
endif()

include(GUDHI_compilation_flags)

# Add your new module in the list, order is not important
include(GUDHI_modules)

add_gudhi_module(common)
add_gudhi_module(Alpha_complex)
add_gudhi_module(Bitmap_cubical_complex)
add_gudhi_module(Bottleneck_distance)
add_gudhi_module(Collapse)
add_gudhi_module(Contraction)
add_gudhi_module(Coxeter_triangulation)
add_gudhi_module(Cech_complex)
add_gudhi_module(Hasse_complex)
add_gudhi_module(Persistence_representations)
add_gudhi_module(Persistent_cohomology)
add_gudhi_module(Rips_complex)
add_gudhi_module(Simplex_tree)
add_gudhi_module(Skeleton_blocker)
add_gudhi_module(Spatial_searching)
add_gudhi_module(Subsampling)
add_gudhi_module(Tangential_complex)
add_gudhi_module(Toplex_map)
add_gudhi_module(Witness_complex)
add_gudhi_module(Nerve_GIC)

# Include module CMake subdirectories
# GUDHI_SUB_DIRECTORIES is managed in CMAKE_MODULE_PATH/GUDHI_modules.cmake
foreach(GUDHI_MODULE ${GUDHI_MODULES})
  foreach(GUDHI_SUB_DIRECTORY ${GUDHI_SUB_DIRECTORIES})
    if(EXISTS ${CMAKE_SOURCE_DIR}/src/${GUDHI_MODULE}/${GUDHI_SUB_DIRECTORY}/CMakeLists.txt)
      add_subdirectory(src/${GUDHI_MODULE}/${GUDHI_SUB_DIRECTORY}/)
    endif()
  endforeach()
endforeach()

if (WITH_GUDHI_GUDHUI)
  add_subdirectory(src/GudhUI)
endif()

if (WITH_GUDHI_PYTHON)
  # specific for cython module
  add_subdirectory(${GUDHI_PYTHON_PATH})
else()
  message("++ Python module will not be compiled because WITH_GUDHI_PYTHON is set to OFF")
  set(GUDHI_MISSING_MODULES ${GUDHI_MISSING_MODULES} "python")
endif()

# For "make user_version" - Requires GUDHI_modules to be performed
include(GUDHI_user_version_target)
# For "make doxygen" - Requires GUDHI_USER_VERSION_DIR to be set - Done in GUDHI_user_version_target for dev version
include(GUDHI_doxygen_target)

configure_file(${CMAKE_SOURCE_DIR}/.github/for_maintainers/new_gudhi_version_creation.md "${CMAKE_CURRENT_BINARY_DIR}/" @ONLY)

message("++ GUDHI_MODULES list is:\"${GUDHI_MODULES}\"")
message("++ GUDHI_MISSING_MODULES list is:\"${GUDHI_MISSING_MODULES}\"")

=== src/GudhUI/CMakeLists.txt ===
project(GudhUI)

# Need to find OpenGL first as find_package(Qt5) tries to #include"GL/gl.h" on some platforms
find_package(OpenGL QUIET)

if (OPENGL_FOUND)
  find_package(Qt5 COMPONENTS Widgets Xml OpenGL QUIET)
  if (Qt5_FOUND)
    find_package(QGLViewer QUIET)
    if ( QGLVIEWER_FOUND)

      if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
        set(CMAKE_AUTOMOC ON)
        set(CMAKE_AUTOUIC ON)
        set(CMAKE_INCLUDE_CURRENT_DIR ON)

        SET(Boost_USE_STATIC_LIBS ON)
        SET(Boost_USE_MULTITHREAD OFF)
        include_directories (${QGLVIEWER_INCLUDE_DIR})

        add_executable  ( GudhUI
          gui/gudhui.cpp
          gui/MainWindow.cpp
          gui/Menu_k_nearest_neighbors.cpp
          gui/Menu_uniform_neighbors.cpp
          gui/Menu_edge_contraction.cpp
          gui/Menu_persistence.cpp
          view/Viewer_instructor.cpp
          view/Viewer.cpp
        )
        target_link_libraries( GudhUI Qt5::Widgets Qt5::Xml Qt5::OpenGL )
        target_link_libraries( GudhUI ${QGLVIEWER_LIBRARIES} )
        target_link_libraries( GudhUI OpenGL::GL OpenGL::GLU )
        if(TARGET TBB::tbb)
          add_compile_definitions( QT_NO_EMIT )
          target_link_libraries( GudhUI TBB::tbb)
        endif()

        install(TARGETS GudhUI DESTINATION bin)
        set(GUDHI_MODULES ${GUDHI_MODULES} "GudhUI" CACHE INTERNAL "GUDHI_MODULES")
      else()
        message("++ GudhUI will not be compiled because CGAL < 4.11.0 or not found")
        set(GUDHI_MISSING_MODULES ${GUDHI_MISSING_MODULES} "GudhUI" CACHE INTERNAL "GUDHI_MISSING_MODULES")
      endif()
    else()
      message("++ GudhUI will not be compiled because QGLViewer is not found")
      set(GUDHI_MISSING_MODULES ${GUDHI_MISSING_MODULES} "GudhUI" CACHE INTERNAL "GUDHI_MISSING_MODULES")
    endif()
  else()
    message("++ GudhUI will not be compiled because Qt5 COMPONENTS Widgets Xml OpenGL are not found")
    set(GUDHI_MISSING_MODULES ${GUDHI_MISSING_MODULES} "GudhUI" CACHE INTERNAL "GUDHI_MISSING_MODULES")
  endif()
else()
  message("++ GudhUI will not be compiled because OpenGL is not found")
  set(GUDHI_MISSING_MODULES ${GUDHI_MISSING_MODULES} "GudhUI" CACHE INTERNAL "GUDHI_MISSING_MODULES")
endif()

=== src/python/CMakeLists.txt ===
project(Cython)

function( add_GUDHI_PYTHON_lib THE_LIB )
  if(EXISTS ${THE_LIB})
    get_filename_component(THE_LIB_FILE_NAME ${THE_LIB} NAME_WE)
    if(WIN32)
      message("++ ${THE_LIB} => THE_LIB_FILE_NAME = ${THE_LIB_FILE_NAME}")
      set(GUDHI_PYTHON_LIBRARIES "${GUDHI_PYTHON_LIBRARIES}'${THE_LIB_FILE_NAME}', " PARENT_SCOPE)
    else(WIN32)
      STRING(REGEX REPLACE "lib" "" UNIX_LIB_FILE_NAME ${THE_LIB_FILE_NAME})
      message("++ ${THE_LIB} => UNIX_LIB_FILE_NAME = ${UNIX_LIB_FILE_NAME}")
      set(GUDHI_PYTHON_LIBRARIES "${GUDHI_PYTHON_LIBRARIES}'${UNIX_LIB_FILE_NAME}', " PARENT_SCOPE)
    endif(WIN32)
  endif(EXISTS ${THE_LIB})
endfunction( add_GUDHI_PYTHON_lib )

function( add_GUDHI_PYTHON_lib_dir)
  # Argument may be a list (specifically on windows with release/debug paths)
  foreach(THE_LIB_DIR IN LISTS ARGN)
    # deals when it is not set - error on windows
    if(EXISTS ${THE_LIB_DIR})
      set(GUDHI_PYTHON_LIBRARY_DIRS "${GUDHI_PYTHON_LIBRARY_DIRS}'${THE_LIB_DIR}', " PARENT_SCOPE)
    else()
      message("add_GUDHI_PYTHON_lib_dir - '${THE_LIB_DIR}' does not exist")
    endif()
  endforeach()
endfunction( add_GUDHI_PYTHON_lib_dir )

# THE_TEST is the python test file name (without .py extension) containing tests functions
function( add_gudhi_py_test THE_TEST )
  if(PYTEST_FOUND)
    # use ${PYTHON_EXECUTABLE} -B, otherwise a __pycache__ directory is created in sources by python
    # use py.test no cache provider, otherwise a .cache file is created in sources by py.test
    add_test(NAME ${THE_TEST}_py_test
             WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
             COMMAND ${PYTHON_EXECUTABLE} -B -m pytest -p no:cacheprovider ${CMAKE_CURRENT_SOURCE_DIR}/test/${THE_TEST}.py)
  endif()
endfunction( add_gudhi_py_test )

# Set gudhi.__debug_info__
# WARNING : to be done before setup.py.in configure_file
function( add_gudhi_debug_info DEBUG_INFO )
  set(GUDHI_PYTHON_DEBUG_INFO "${GUDHI_PYTHON_DEBUG_INFO}    \"${DEBUG_INFO}\\n\" \\\n" PARENT_SCOPE)
endfunction( add_gudhi_debug_info )

if(PYTHONINTERP_FOUND)
  if(NUMPY_FOUND AND PYBIND11_FOUND AND CYTHON_FOUND)
    add_gudhi_debug_info("Pybind11 version ${PYBIND11_VERSION}")
    # PyBind11 modules
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'bottleneck', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'hera', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'clustering', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'datasets', ")

    # Cython modules
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'off_utils', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'simplex_tree', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'rips_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'cubical_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'periodic_cubical_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'persistence_graphical_tools', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'reader_utils', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'witness_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'strong_witness_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'nerve_gic', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'subsampling', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'tangential_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'alpha_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'euclidean_witness_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'euclidean_strong_witness_complex', ")
    # Modules that should not be auto-imported in __init__.py
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'representations', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'sklearn', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'tensorflow', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'wasserstein', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'point_cloud', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'weighted_rips_complex', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'dtm_rips_complex', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'cover_complex', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'flag_filtration', ")

    add_gudhi_debug_info("Python version ${PYTHON_VERSION_STRING}")
    add_gudhi_debug_info("Cython version ${CYTHON_VERSION}")
    if(PYTEST_FOUND)
      add_gudhi_debug_info("Pytest version ${PYTEST_VERSION}")
    endif()
    if(MATPLOTLIB_FOUND)
      add_gudhi_debug_info("Matplotlib version ${MATPLOTLIB_VERSION}")
    endif()
    if(NUMPY_FOUND)
      add_gudhi_debug_info("Numpy version ${NUMPY_VERSION}")
    endif()
    if(SCIPY_FOUND)
      add_gudhi_debug_info("Scipy version ${SCIPY_VERSION}")
    endif()
    if(SKLEARN_FOUND)
      add_gudhi_debug_info("Scikit-learn version ${SKLEARN_VERSION}")
    endif()
    if(OT_FOUND)
      add_gudhi_debug_info("POT version ${OT_VERSION}")
    endif()
    if(HNSWLIB_FOUND)
      # Does not have a version number...
      add_gudhi_debug_info("HNSWlib found")
    endif()
    if(TORCH_FOUND)
      add_gudhi_debug_info("PyTorch version ${TORCH_VERSION}")
    endif()
    if(PYKEOPS_FOUND)
      add_gudhi_debug_info("PyKeOps version ${PYKEOPS_VERSION}")
    endif()
    if(EAGERPY_FOUND)
      add_gudhi_debug_info("EagerPy version ${EAGERPY_VERSION}")
    endif()
    if(TENSORFLOW_FOUND)
      add_gudhi_debug_info("TensorFlow version ${TENSORFLOW_VERSION}")
    endif()
    if(SPHINX_FOUND)
      add_gudhi_debug_info("Sphinx version ${SPHINX_VERSION}")
    endif()
    if(SPHINX_PARAMLINKS_FOUND)
      add_gudhi_debug_info("Sphinx-paramlinks version ${SPHINX_PARAMLINKS_VERSION}")
    endif()
    if(PYDATA_SPHINX_THEME_FOUND)
      add_gudhi_debug_info("pydata_sphinx_theme version ${PYDATA_SPHINX_THEME_VERSION}")
    endif()
    if(SPHINXCONTRIB.BIBTEX_FOUND)
      # Does not have a version number...
      add_gudhi_debug_info("sphinxcontrib-bibtex found")
    endif()
    if(NETWORKX_FOUND)
      add_gudhi_debug_info("NetworkX version ${NETWORKX_VERSION}")
    endif()

    set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DBOOST_RESULT_OF_USE_DECLTYPE', ")
    set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DBOOST_ALL_NO_LIB', ")
    set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DBOOST_SYSTEM_NO_DEPRECATED', ")

    # Gudhi and CGAL compilation option
    if(MSVC)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'/std:c++17', ")
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'/fp:strict', ")
      # cf. https://github.com/oneapi-src/oneTBB/issues/573
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DNOMINMAX', ")
    else(MSVC)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-std=c++17', ")
    endif(MSVC)
    if(CMAKE_COMPILER_IS_GNUCXX)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-frounding-math', ")
      set(GUDHI_PYBIND11_EXTRA_COMPILE_ARGS "${GUDHI_PYBIND11_EXTRA_COMPILE_ARGS}'-fvisibility=hidden', ")
    endif(CMAKE_COMPILER_IS_GNUCXX)
    if (CMAKE_CXX_COMPILER_ID MATCHES Intel)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-fp-model strict', ")
    endif(CMAKE_CXX_COMPILER_ID MATCHES Intel)
    if (DEBUG_TRACES)
      # For programs to be more verbose
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DDEBUG_TRACES', ")
    endif()

    if (EIGEN3_FOUND)
      add_gudhi_debug_info("Eigen3 version ${EIGEN3_VERSION}")
      # No problem, even if no CGAL found
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_EIGEN3_ENABLED', ")
    endif (EIGEN3_FOUND)

    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'off_utils', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'simplex_tree', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'rips_complex', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'cubical_complex', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'periodic_cubical_complex', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'reader_utils', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'witness_complex', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'strong_witness_complex', ")
    set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'clustering/_tomato', ")
    set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'hera/wasserstein', ")
    set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'hera/bottleneck', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'nerve_gic', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'subsampling', ")
    if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
      set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'datasets/generators/_points', ")
      set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'bottleneck', ")
    endif ()
    if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)
      set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'tangential_complex', ")
      set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'euclidean_witness_complex', ")
      set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'euclidean_strong_witness_complex', ")
    endif ()
    if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.1.0)
      set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'alpha_complex', ")
    endif ()
    set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'_pers_cub_low_dim', ")
    set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'_edge_collapse', ")

    # from windows vcpkg eigen 3.4.0#2 : build fails with
    # error C2440: '<function-style-cast>': cannot convert from 'Eigen::EigenBase<Derived>::Index' to '__gmp_expr<mpq_t,mpq_t>'
    # cf. https://gitlab.com/libeigen/eigen/-/issues/2476
    # Workaround is to compile with '-DEIGEN_DEFAULT_DENSE_INDEX_TYPE=int'
    if (FORCE_EIGEN_DEFAULT_DENSE_INDEX_TYPE_TO_INT)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DEIGEN_DEFAULT_DENSE_INDEX_TYPE=int', ")
    endif()


    add_gudhi_debug_info("Boost version ${Boost_VERSION}")
    if(CGAL_FOUND)
      if(NOT CGAL_VERSION VERSION_LESS 5.3.0)
        # CGAL_HEADER_ONLY has been dropped for CGAL >= 5.3. Only the header-only version is supported.
        set(CGAL_HEADER_ONLY True)
      endif(NOT CGAL_VERSION VERSION_LESS 5.3.0)
      # Add CGAL compilation args
      if(CGAL_HEADER_ONLY)
        add_gudhi_debug_info("CGAL header only version ${CGAL_VERSION}")
        set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_HEADER_ONLY', ")
      else(CGAL_HEADER_ONLY)
        add_gudhi_debug_info("CGAL version ${CGAL_VERSION}")
        add_GUDHI_PYTHON_lib("${CGAL_LIBRARY}")
        add_GUDHI_PYTHON_lib_dir(${CGAL_LIBRARIES_DIR})
        message("** Add CGAL ${CGAL_LIBRARIES_DIR}")
        # If CGAL is not header only, CGAL library may link with boost system,
        if(CMAKE_BUILD_TYPE MATCHES Debug)
          add_GUDHI_PYTHON_lib("${Boost_SYSTEM_LIBRARY_DEBUG}")
        else()
          add_GUDHI_PYTHON_lib("${Boost_SYSTEM_LIBRARY_RELEASE}")
        endif()
        add_GUDHI_PYTHON_lib_dir(${Boost_LIBRARY_DIRS})
        message("** Add Boost ${Boost_LIBRARY_DIRS}")
      endif(CGAL_HEADER_ONLY)
      # GMP and GMPXX are not required, but if present, CGAL will link with them.
      if(GMP_FOUND)
        add_gudhi_debug_info("GMP_LIBRARIES = ${GMP_LIBRARIES}")
        set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_USE_GMP', ")
        add_GUDHI_PYTHON_lib("${GMP_LIBRARIES}")

=== src/Alpha_complex/benchmark/CMakeLists.txt ===
project(Alpha_complex_benchmark)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)
  add_executable(Alpha_complex_3d_benchmark Alpha_complex_3d_benchmark.cpp)
  target_link_libraries(Alpha_complex_3d_benchmark ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Alpha_complex_3d_benchmark TBB::tbb)
  endif()
endif ()

=== src/Alpha_complex/example/CMakeLists.txt ===
project(Alpha_complex_examples)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)
  add_executable ( Alpha_complex_example_from_points Alpha_complex_from_points.cpp )
  target_link_libraries(Alpha_complex_example_from_points  ${CGAL_LIBRARY})
  add_executable ( Alpha_complex_example_from_off Alpha_complex_from_off.cpp )
  target_link_libraries(Alpha_complex_example_from_off ${CGAL_LIBRARY})
  add_executable ( Alpha_complex_example_fast_from_off Fast_alpha_complex_from_off.cpp )
  target_link_libraries(Alpha_complex_example_fast_from_off ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Alpha_complex_example_from_points TBB::tbb)
    target_link_libraries(Alpha_complex_example_from_off TBB::tbb)
    target_link_libraries(Alpha_complex_example_fast_from_off TBB::tbb)
  endif()

  add_test(NAME Alpha_complex_example_from_points COMMAND $<TARGET_FILE:Alpha_complex_example_from_points>)

  add_test(NAME Alpha_complex_example_from_off_60 COMMAND $<TARGET_FILE:Alpha_complex_example_from_off>
      "${CMAKE_SOURCE_DIR}/data/points/alphacomplexdoc.off" "60.0" "${CMAKE_CURRENT_BINARY_DIR}/alphaoffreader_result_60.txt")
  add_test(NAME Alpha_complex_example_from_off_32 COMMAND $<TARGET_FILE:Alpha_complex_example_from_off>
      "${CMAKE_SOURCE_DIR}/data/points/alphacomplexdoc.off" "32.0" "${CMAKE_CURRENT_BINARY_DIR}/alphaoffreader_result_32.txt")

  add_test(NAME Alpha_complex_example_fast_from_off_60 COMMAND $<TARGET_FILE:Alpha_complex_example_fast_from_off>
      "${CMAKE_SOURCE_DIR}/data/points/alphacomplexdoc.off" "60.0" "${CMAKE_CURRENT_BINARY_DIR}/fastalphaoffreader_result_60.txt")
  add_test(NAME Alpha_complex_example_fast_from_off_32 COMMAND $<TARGET_FILE:Alpha_complex_example_fast_from_off>
      "${CMAKE_SOURCE_DIR}/data/points/alphacomplexdoc.off" "32.0" "${CMAKE_CURRENT_BINARY_DIR}/fastalphaoffreader_result_32.txt")

  if (DIFF_PATH)
    # Do not forget to copy test results files in current binary dir
    file(COPY "alphaoffreader_for_doc_32.txt" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
    file(COPY "alphaoffreader_for_doc_60.txt" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

    add_test(Alpha_complex_example_from_off_60_diff_files ${DIFF_PATH}
        ${CMAKE_CURRENT_BINARY_DIR}/alphaoffreader_result_60.txt ${CMAKE_CURRENT_BINARY_DIR}/alphaoffreader_for_doc_60.txt)
    set_tests_properties(Alpha_complex_example_from_off_60_diff_files PROPERTIES DEPENDS Alpha_complex_example_from_off_60) 
    add_test(Alpha_complex_example_from_off_32_diff_files ${DIFF_PATH}
        ${CMAKE_CURRENT_BINARY_DIR}/alphaoffreader_result_32.txt ${CMAKE_CURRENT_BINARY_DIR}/alphaoffreader_for_doc_32.txt)
    set_tests_properties(Alpha_complex_example_from_off_32_diff_files PROPERTIES DEPENDS Alpha_complex_example_from_off_32) 

    add_test(Alpha_complex_example_fast_from_off_60_diff_files ${DIFF_PATH}
        ${CMAKE_CURRENT_BINARY_DIR}/fastalphaoffreader_result_60.txt ${CMAKE_CURRENT_BINARY_DIR}/alphaoffreader_for_doc_60.txt)
    set_tests_properties(Alpha_complex_example_fast_from_off_60_diff_files PROPERTIES DEPENDS Alpha_complex_example_fast_from_off_60) 
    add_test(Alpha_complex_example_fast_from_off_32_diff_files ${DIFF_PATH}
        ${CMAKE_CURRENT_BINARY_DIR}/fastalphaoffreader_result_32.txt ${CMAKE_CURRENT_BINARY_DIR}/alphaoffreader_for_doc_32.txt)
    set_tests_properties(Alpha_complex_example_fast_from_off_32_diff_files PROPERTIES DEPENDS Alpha_complex_example_fast_from_off_32) 
  endif()
endif(NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
  add_executable ( Alpha_complex_example_weighted_3d_from_points Weighted_alpha_complex_3d_from_points.cpp )
  target_link_libraries(Alpha_complex_example_weighted_3d_from_points  ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Alpha_complex_example_weighted_3d_from_points TBB::tbb)
  endif()
  add_test(NAME Alpha_complex_example_weighted_3d_from_points
          COMMAND $<TARGET_FILE:Alpha_complex_example_weighted_3d_from_points>)

  add_executable ( Alpha_complex_example_3d_from_points Alpha_complex_3d_from_points.cpp )
  target_link_libraries(Alpha_complex_example_3d_from_points  ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Alpha_complex_example_3d_from_points TBB::tbb)
  endif()
  add_test(NAME Alpha_complex_example_3d_from_points
          COMMAND $<TARGET_FILE:Alpha_complex_example_3d_from_points>)

endif(NOT CGAL_VERSION VERSION_LESS 4.11.0)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.1.0)
  add_executable ( Weighted_alpha_complex_example_from_points Weighted_alpha_complex_from_points.cpp )
  target_link_libraries(Weighted_alpha_complex_example_from_points  ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Weighted_alpha_complex_example_from_points TBB::tbb)
  endif()
  add_test(NAME Weighted_alpha_complex_example_from_points COMMAND $<TARGET_FILE:Weighted_alpha_complex_example_from_points>)
endif(NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.1.0)

=== src/Alpha_complex/test/CMakeLists.txt ===
project(Alpha_complex_tests)

include(GUDHI_boost_test)
if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)

  # Do not forget to copy test files in current binary dir
  file(COPY "${CMAKE_SOURCE_DIR}/data/points/alphacomplexdoc.off" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

  add_executable ( Alpha_complex_test_unit Alpha_complex_unit_test.cpp )
  target_link_libraries(Alpha_complex_test_unit ${CGAL_LIBRARY})
  add_executable ( Alpha_complex_dim3_Epeck_dynamic_test_unit Alpha_complex_dim3_Epeck_dynamic_unit_test.cpp )
  target_link_libraries(Alpha_complex_dim3_Epeck_dynamic_test_unit ${CGAL_LIBRARY})
  add_executable ( Alpha_complex_dim3_Epeck_static_test_unit Alpha_complex_dim3_Epeck_static_unit_test.cpp )
  target_link_libraries(Alpha_complex_dim3_Epeck_static_test_unit ${CGAL_LIBRARY})
  add_executable ( Alpha_complex_dim3_Epick_dynamic_test_unit Alpha_complex_dim3_Epick_dynamic_unit_test.cpp )
  target_link_libraries(Alpha_complex_dim3_Epick_dynamic_test_unit ${CGAL_LIBRARY})
  add_executable ( Alpha_complex_dim3_Epick_static_test_unit Alpha_complex_dim3_Epick_static_unit_test.cpp )
  target_link_libraries(Alpha_complex_dim3_Epick_static_test_unit ${CGAL_LIBRARY})
  add_executable ( Delaunay_complex_Epeck_dynamic_test_unit Delaunay_complex_Epeck_dynamic_unit_test.cpp )
  target_link_libraries(Delaunay_complex_Epeck_dynamic_test_unit ${CGAL_LIBRARY})
  add_executable ( Delaunay_complex_Epeck_static_test_unit Delaunay_complex_Epeck_static_unit_test.cpp )
  target_link_libraries(Delaunay_complex_Epeck_static_test_unit ${CGAL_LIBRARY})
  add_executable ( Delaunay_complex_Epick_dynamic_test_unit Delaunay_complex_Epick_dynamic_unit_test.cpp )
  target_link_libraries(Delaunay_complex_Epick_dynamic_test_unit ${CGAL_LIBRARY})
  add_executable ( Delaunay_complex_Epick_static_test_unit Delaunay_complex_Epick_static_unit_test.cpp )
  target_link_libraries(Delaunay_complex_Epick_static_test_unit ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Alpha_complex_test_unit TBB::tbb)
    target_link_libraries(Alpha_complex_dim3_Epeck_dynamic_test_unit TBB::tbb)
    target_link_libraries(Alpha_complex_dim3_Epeck_static_test_unit TBB::tbb)
    target_link_libraries(Alpha_complex_dim3_Epick_dynamic_test_unit TBB::tbb)
    target_link_libraries(Alpha_complex_dim3_Epick_static_test_unit TBB::tbb)
    target_link_libraries(Delaunay_complex_Epeck_dynamic_test_unit TBB::tbb)
    target_link_libraries(Delaunay_complex_Epeck_static_test_unit TBB::tbb)
    target_link_libraries(Delaunay_complex_Epick_dynamic_test_unit TBB::tbb)
    target_link_libraries(Delaunay_complex_Epick_static_test_unit TBB::tbb)
  endif()

  gudhi_add_boost_test(Alpha_complex_test_unit)
  gudhi_add_boost_test(Alpha_complex_dim3_Epeck_dynamic_test_unit)
  gudhi_add_boost_test(Alpha_complex_dim3_Epeck_static_test_unit)
  gudhi_add_boost_test(Alpha_complex_dim3_Epick_dynamic_test_unit)
  gudhi_add_boost_test(Alpha_complex_dim3_Epick_static_test_unit)
  gudhi_add_boost_test(Delaunay_complex_Epeck_dynamic_test_unit)
  gudhi_add_boost_test(Delaunay_complex_Epeck_static_test_unit)
  gudhi_add_boost_test(Delaunay_complex_Epick_dynamic_test_unit)
  gudhi_add_boost_test(Delaunay_complex_Epick_static_test_unit)

endif (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)

  add_executable ( Alpha_complex_3d_test_unit Alpha_complex_3d_unit_test.cpp )
  target_link_libraries(Alpha_complex_3d_test_unit ${CGAL_LIBRARY})
  add_executable ( Weighted_alpha_complex_3d_test_unit Weighted_alpha_complex_3d_unit_test.cpp )
  target_link_libraries(Weighted_alpha_complex_3d_test_unit ${CGAL_LIBRARY})
  add_executable ( Periodic_alpha_complex_3d_test_unit Periodic_alpha_complex_3d_unit_test.cpp )
  target_link_libraries(Periodic_alpha_complex_3d_test_unit ${CGAL_LIBRARY})
  add_executable ( Weighted_periodic_alpha_complex_3d_test_unit Weighted_periodic_alpha_complex_3d_unit_test.cpp )
  target_link_libraries(Weighted_periodic_alpha_complex_3d_test_unit ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Alpha_complex_3d_test_unit TBB::tbb)
    target_link_libraries(Weighted_alpha_complex_3d_test_unit TBB::tbb)
    target_link_libraries(Periodic_alpha_complex_3d_test_unit TBB::tbb)
    target_link_libraries(Weighted_periodic_alpha_complex_3d_test_unit TBB::tbb)
  endif()

  gudhi_add_boost_test(Alpha_complex_3d_test_unit)
  gudhi_add_boost_test(Weighted_alpha_complex_3d_test_unit)
  gudhi_add_boost_test(Periodic_alpha_complex_3d_test_unit)
  gudhi_add_boost_test(Weighted_periodic_alpha_complex_3d_test_unit)

endif (NOT CGAL_VERSION VERSION_LESS 4.11.0)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.1.0)
  add_executable ( Alpha_kernel_d_Epeck_dynamic_test_unit Alpha_kernel_d_Epeck_dynamic_unit_test.cpp )
  add_executable ( Alpha_kernel_d_Epeck_static_test_unit Alpha_kernel_d_Epeck_static_unit_test.cpp )
  add_executable ( Alpha_kernel_d_Epick_dynamic_test_unit Alpha_kernel_d_Epick_dynamic_unit_test.cpp )
  add_executable ( Alpha_kernel_d_Epick_static_test_unit Alpha_kernel_d_Epick_static_unit_test.cpp )
  target_link_libraries(Alpha_kernel_d_Epeck_dynamic_test_unit ${CGAL_LIBRARY})
  target_link_libraries(Alpha_kernel_d_Epeck_static_test_unit ${CGAL_LIBRARY})
  target_link_libraries(Alpha_kernel_d_Epick_dynamic_test_unit ${CGAL_LIBRARY})
  target_link_libraries(Alpha_kernel_d_Epick_static_test_unit ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Alpha_kernel_d_Epeck_dynamic_test_unit TBB::tbb)
    target_link_libraries(Alpha_kernel_d_Epeck_static_test_unit TBB::tbb)
    target_link_libraries(Alpha_kernel_d_Epick_dynamic_test_unit TBB::tbb)
    target_link_libraries(Alpha_kernel_d_Epick_static_test_unit TBB::tbb)
  endif()
  gudhi_add_boost_test(Alpha_kernel_d_Epeck_dynamic_test_unit)
  gudhi_add_boost_test(Alpha_kernel_d_Epeck_static_test_unit)
  gudhi_add_boost_test(Alpha_kernel_d_Epick_dynamic_test_unit)
  gudhi_add_boost_test(Alpha_kernel_d_Epick_static_test_unit)
  
  add_executable ( Weighted_alpha_complex_test_unit Weighted_alpha_complex_unit_test.cpp )
  target_link_libraries(Weighted_alpha_complex_test_unit ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Weighted_alpha_complex_test_unit TBB::tbb)
  endif()
  gudhi_add_boost_test(Weighted_alpha_complex_test_unit)

  add_executable ( Weighted_alpha_complex_non_visible_points_test_unit Weighted_alpha_complex_non_visible_points_unit_test.cpp )
  target_link_libraries(Weighted_alpha_complex_non_visible_points_test_unit ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Weighted_alpha_complex_non_visible_points_test_unit TBB::tbb)
  endif()
  gudhi_add_boost_test(Weighted_alpha_complex_non_visible_points_test_unit)

  add_executable ( Zero_weighted_alpha_complex_dynamic_test_unit Zero_weighted_alpha_complex_dynamic_unit_test.cpp )
  target_link_libraries(Zero_weighted_alpha_complex_dynamic_test_unit ${CGAL_LIBRARY})
  add_executable ( Zero_weighted_alpha_complex_static_test_unit Zero_weighted_alpha_complex_static_unit_test.cpp )
  target_link_libraries(Zero_weighted_alpha_complex_static_test_unit ${CGAL_LIBRARY})
  if(TARGET TBB::tbb)
    target_link_libraries(Zero_weighted_alpha_complex_dynamic_test_unit TBB::tbb)
    target_link_libraries(Zero_weighted_alpha_complex_static_test_unit TBB::tbb)
  endif()
  gudhi_add_boost_test(Zero_weighted_alpha_complex_dynamic_test_unit)
  gudhi_add_boost_test(Zero_weighted_alpha_complex_static_test_unit)

endif (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.1.0)

=== src/Alpha_complex/utilities/CMakeLists.txt ===
project(Alpha_complex_utilities)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.1.0)
  if (TARGET Boost::program_options)
    add_executable (alpha_complex_persistence alpha_complex_persistence.cpp)
    target_link_libraries(alpha_complex_persistence ${CGAL_LIBRARY} Boost::program_options)

    if(TARGET TBB::tbb)
      target_link_libraries(alpha_complex_persistence TBB::tbb)
    endif()
    add_test(NAME Alpha_complex_utilities_safe_alpha_complex_persistence COMMAND $<TARGET_FILE:alpha_complex_persistence>
        "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off" "-p" "2" "-m" "0.45" "-o" "safe.pers")
    add_test(NAME Alpha_complex_utilities_fast_alpha_complex_persistence COMMAND $<TARGET_FILE:alpha_complex_persistence>
        "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off" "-p" "2" "-m" "0.45" "-o" "fast.pers" "-f")
    add_test(NAME Alpha_complex_utilities_exact_alpha_complex_persistence COMMAND $<TARGET_FILE:alpha_complex_persistence>
        "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off" "-p" "2" "-m" "0.45" "-o" "exact.pers" "-e")
    if (DIFF_PATH)
      add_test(Alpha_complex_utilities_diff_exact_alpha_complex ${DIFF_PATH}
               "exact.pers" "safe.pers")
      set_tests_properties(Alpha_complex_utilities_diff_exact_alpha_complex PROPERTIES DEPENDS
               "Alpha_complex_utilities_exact_alpha_complex_persistence;Alpha_complex_utilities_safe_alpha_complex_persistence")

      add_test(Alpha_complex_utilities_diff_fast_alpha_complex ${DIFF_PATH}
               "fast.pers" "safe.pers")
      set_tests_properties(Alpha_complex_utilities_diff_fast_alpha_complex PROPERTIES DEPENDS
               "Alpha_complex_utilities_fast_alpha_complex_persistence;Alpha_complex_utilities_safe_alpha_complex_persistence")
    endif()

    install(TARGETS alpha_complex_persistence DESTINATION bin)
  endif()
endif (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.1.0)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
  if (TARGET Boost::program_options)
    add_executable(alpha_complex_3d_persistence alpha_complex_3d_persistence.cpp)
    target_link_libraries(alpha_complex_3d_persistence ${CGAL_LIBRARY} Boost::program_options)
    if(TARGET TBB::tbb)
      target_link_libraries(alpha_complex_3d_persistence TBB::tbb)
    endif()

    add_test(NAME Alpha_complex_utilities_alpha_complex_3d COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
            "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off"
            "-p" "2" "-m" "0.45" "-o" "safe_3d.pers")

    add_test(NAME Alpha_complex_utilities_exact_alpha_complex_3d COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
            "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off"
            "-p" "2" "-m" "0.45" "-o" "exact_3d.pers" "-e")

    add_test(NAME Alpha_complex_utilities_fast_alpha_complex_3d COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
            "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off"
            "-p" "2" "-m" "0.45" "-o" "fast_3d.pers" "-f")

    if (DIFF_PATH)
      add_test(Alpha_complex_utilities_diff_exact_alpha_complex_3d ${DIFF_PATH}
              "exact_3d.pers" "safe_3d.pers")
      set_tests_properties(Alpha_complex_utilities_diff_exact_alpha_complex_3d PROPERTIES DEPENDS
              "Alpha_complex_utilities_exact_alpha_complex_3d;Alpha_complex_utilities_alpha_complex_3d")
      add_test(Alpha_complex_utilities_diff_fast_alpha_complex_3d ${DIFF_PATH}
              "fast_3d.pers" "safe_3d.pers")
      set_tests_properties(Alpha_complex_utilities_diff_fast_alpha_complex_3d PROPERTIES DEPENDS
              "Alpha_complex_utilities_fast_alpha_complex_3d;Alpha_complex_utilities_alpha_complex_3d")
    endif()

    add_test(NAME Alpha_complex_utilities_periodic_alpha_complex_3d_persistence COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
            "${CMAKE_SOURCE_DIR}/data/points/grid_10_10_10_in_0_1.off"
            "-c" "${CMAKE_SOURCE_DIR}/data/points/iso_cuboid_3_in_0_1.txt"
            "-p" "2" "-m" "0")

    add_test(NAME Alpha_complex_utilities_weighted_alpha_complex_3d COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
            "${CMAKE_SOURCE_DIR}/data/points/grid_10_10_10_in_0_1.off"
            "-w" "${CMAKE_SOURCE_DIR}/data/points/grid_10_10_10_in_0_1.weights"
            "-p" "2" "-m" "0")

    add_test(NAME Alpha_complex_utilities_weighted_periodic_alpha_complex_3d COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
        "${CMAKE_SOURCE_DIR}/data/points/grid_10_10_10_in_0_1.off"
        "-w" "${CMAKE_SOURCE_DIR}/data/points/grid_10_10_10_in_0_1.weights"
        "-c" "${CMAKE_SOURCE_DIR}/data/points/iso_cuboid_3_in_0_1.txt"
        "-p" "2" "-m" "0" "-e")
  
    install(TARGETS alpha_complex_3d_persistence DESTINATION bin)
  endif()
endif (NOT CGAL_VERSION VERSION_LESS 4.11.0)

=== src/Bitmap_cubical_complex/benchmark/CMakeLists.txt ===
project(Bitmap_cubical_complex_benchmark)

add_executable(bitmap_cubical_complex_benchmark bitmap_cubical_complex_benchmark.cpp)
if(TARGET TBB::tbb)
  target_link_libraries(bitmap_cubical_complex_benchmark TBB::tbb)
endif()

=== src/Bitmap_cubical_complex/example/CMakeLists.txt ===
project(Bitmap_cubical_complex_examples)

add_executable ( Random_bitmap_cubical_complex Random_bitmap_cubical_complex.cpp )
if(TARGET TBB::tbb)
  target_link_libraries(Random_bitmap_cubical_complex TBB::tbb)
endif()
add_test(NAME Bitmap_cubical_complex_example_random COMMAND $<TARGET_FILE:Random_bitmap_cubical_complex>
    "2" "100" "100")

=== src/Bitmap_cubical_complex/test/CMakeLists.txt ===
project(Bitmap_cubical_complex_tests)

include(GUDHI_boost_test)

# Do not forget to copy test files in current binary dir
file(COPY "${CMAKE_SOURCE_DIR}/data/bitmap/sinusoid.txt" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

add_executable ( Bitmap_cubical_complex_test_unit Bitmap_test.cpp )
if(TARGET TBB::tbb)
  target_link_libraries(Bitmap_cubical_complex_test_unit TBB::tbb)
endif()

gudhi_add_boost_test(Bitmap_cubical_complex_test_unit)

=== src/Bitmap_cubical_complex/utilities/CMakeLists.txt ===
project(Bitmap_cubical_complex_utilities)

add_executable ( cubical_complex_persistence cubical_complex_persistence.cpp )
if(TARGET TBB::tbb)
  target_link_libraries(cubical_complex_persistence TBB::tbb)
endif()

add_test(NAME Bitmap_cubical_complex_utility_persistence_one_sphere COMMAND $<TARGET_FILE:cubical_complex_persistence>
    "${CMAKE_SOURCE_DIR}/data/bitmap/CubicalOneSphere.txt")

add_test(NAME Bitmap_cubical_complex_utility_persistence_two_sphere COMMAND $<TARGET_FILE:cubical_complex_persistence>
    "${CMAKE_SOURCE_DIR}/data/bitmap/CubicalTwoSphere.txt")

add_executable ( periodic_cubical_complex_persistence periodic_cubical_complex_persistence.cpp )
if(TARGET TBB::tbb)
  target_link_libraries(periodic_cubical_complex_persistence TBB::tbb)
endif()

add_test(NAME Bitmap_cubical_complex_utility_periodic_boundary_conditions_2d_torus
    COMMAND $<TARGET_FILE:periodic_cubical_complex_persistence>
    "${CMAKE_SOURCE_DIR}/data/bitmap/2d_torus.txt")

add_test(NAME Bitmap_cubical_complex_utility_periodic_boundary_conditions_3d_torus
    COMMAND $<TARGET_FILE:periodic_cubical_complex_persistence>
    "${CMAKE_SOURCE_DIR}/data/bitmap/3d_torus.txt")

install(TARGETS cubical_complex_persistence DESTINATION bin)
install(TARGETS periodic_cubical_complex_persistence DESTINATION bin)

=== src/Bottleneck_distance/benchmark/CMakeLists.txt ===
project(Bottleneck_distance_benchmark)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
  add_executable ( bottleneck_chrono bottleneck_chrono.cpp )
  if(TARGET TBB::tbb)
    target_link_libraries(bottleneck_chrono TBB::tbb)
  endif()
endif(NOT CGAL_VERSION VERSION_LESS 4.11.0)

=== debian/control ===
Source: gudhi
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Gard Spreemann <gspr@nonempty.org>
Section: math
Priority: optional
Standards-Version: 4.6.2.0
Build-Depends: cmake (>= 3.8),
               cython3 (>= 3.0.0),
               debhelper-compat (= 13),
               dh-python,
               libboost-filesystem-dev (>= 1.71),
               libboost-program-options-dev (>= 1.71),
               libboost-system-dev (>= 1.71),
               libboost-test-dev (>= 1.71),
               libboost-thread-dev (>= 1.71),
               libboost-timer-dev (>= 1.71),
               libcgal-dev (>= 5.5.1),
               libcgal-qt5-dev (>= 5.5.1),
               libeigen3-dev,
               libgmp-dev,
               libhera-dev (>= 2.0.0),
               libqglviewer-dev-qt5,
               libtbb-dev,
               pybind11-dev,
               python3-all-dev,
               python3-eagerpy,
               python3-matplotlib,
               python3-numpy,
               python3-pot,
               python3-pybind11,
               python3-pytest,
               python3-scipy,
               python3-setuptools,
               python3-sklearn,
               python3-tk,
               qtbase5-dev
Build-Depends-Indep: doxygen,
                     graphviz
Rules-Requires-Root: no
Homepage: https://gudhi.inria.fr/
Vcs-Browser: https://salsa.debian.org/gspr/gudhi
Vcs-Git: https://salsa.debian.org/gspr/gudhi.git -b debian/sid

Package: libgudhi-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: libboost-filesystem-dev (>= 1.71),
         libboost-program-options-dev (>= 1.71),
         libboost-system-dev (>= 1.71),
         libboost-test-dev (>= 1.71),
         libboost-thread-dev (>= 1.71),
         libboost-timer-dev (>= 1.71),
         libcgal-dev (>= 5.5.1),
         libeigen3-dev (>= 3.1.0),
         libgmp-dev (>= 4.2),
         libtbb-dev,
         ${misc:Depends}
Suggests: libgudhi-doc, libgudhi-examples, libhera-dev
Description: Generic open source C++ library for topological data analysis
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains the header files. See the libgudhi-examples
 package for example programs using the library.

Package: libgudhi-examples
Section: misc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libgudhi-dev, libgudhi-doc
Description: Example programs for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains some source code examples.

Package: libgudhi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-mathjax, ${misc:Depends}
Description: Documentation for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains documentation.

Package: python3-gudhi
Section: python
Architecture: amd64 arm64 i386 ia64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64 x32
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Recommends: python3-eagerpy,
            python3-matplotlib,
            python3-pot,
            python3-scipy,
            python3-sklearn
Description: Python 3 interface to the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains GUDHI's Python (3) interface.

Package: gudhui
Section: math
Architecture: amd64 arm64 i386 ia64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64 x32
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: GUI for some of the functionality of the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains GudhUI, a graphical interface to a few of GUDHI's
 features. Be aware that it is quite rough around the edges.

Package: gudhi-utils
Section: math
Architecture: amd64 arm64 i386 ia64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64 x32
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Utilities from the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains some utilities built with the GUDHI library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

TMPBIN:=debian/tmp/usr/bin

PY3VERS:=$(shell py3versions -vs)

DHFLAGS+=--buildsystem=cmake

# To fix #945226, we turn off parallel builds everywhere, except if
# someone explicitly wants them enabled by setting the environment
# variable ALLOW_PARALLEL.
ifeq (, $(ALLOW_PARALLEL))
	DHFLAGS+=--no-parallel
endif

# The buildds run out of memory on some architectures. On those, we
# tune the GCC garbage collector and force non-parallel building.
ifneq (, $(filter $(shell dpkg-architecture --query DEB_BUILD_ARCH),armhf arm64 i386 mips mipsel m68k powerpcspe x32))
	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=5
# We have disabled parallel builds in general now. Consider disabling
# for certain architectures if it's reenabled globally.
#	DHFLAGS+=--no-parallel
endif

# Disable tests on i386 due to rounding problem in some. See upstream GitHub issue #118.
ifneq (, $(filter $(shell dpkg-architecture --query DEB_BUILD_ARCH),i386 x32))
	export DEB_BUILD_MAINT_OPTIONS := $(DEB_BUILD_MAINT_OPTIONS) nocheck
endif

%:
	dh $@ $(DHFLAGS) --with=python3,numpy3

execute_before_dh_auto_configure:
	dh_auto_configure $(DHFLAGS) --builddirectory=build -- -DWITH_GUDHI_BENCHMARK=true -DWITH_GUDHI_EXAMPLE=true -DWITH_GUDHI_PYTHON=false -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=true -DWITH_GUDHI_GUDHUI=true -DWITH_GUDHI_REMOTE_TEST=false -DUSER_VERSION_DIR=userversion -DHERA_INCLUDE_DIR=/usr/include
	make -C build user_version
	for py3ver in $(PY3VERS) ; do \
		dh_auto_configure $(DHFLAGS) --builddirectory=build-py$$py3ver -- -DWITH_GUDHI_BENCHMARK=false -DWITH_GUDHI_EXAMPLE=false -DWITH_GUDHI_PYTHON=true -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=false  -DWITH_GUDHI_GUDHUI=false -DWITH_GUDHI_REMOTE_TEST=false -DPython_ADDITIONAL_VERSIONS=$$py3ver -DUSER_VERSION_DIR=userversion -DWITH_GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS=false -DHERA_INCLUDE_DIR=/usr/include ; \
		make -C build-py$$py3ver user_version ; \
	done

override_dh_auto_configure:
	dh_auto_configure $(DHFLAGS) --sourcedir=build/userversion --builddirectory=build/userversion/build -- -DWITH_GUDHI_BENCHMARK=true -DWITH_GUDHI_EXAMPLE=true -DWITH_GUDHI_PYTHON=false -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=true -DWITH_GUDHI_GUDHUI=true -DWITH_GUDHI_REMOTE_TEST=false -DHERA_INCLUDE_DIR=/usr/include
	for py3ver in $(PY3VERS) ; do \
		dh_auto_configure $(DHFLAGS) --sourcedir=build-py$$py3ver/userversion --builddirectory=build-py$$py3ver/userversion/build -- -DWITH_GUDHI_BENCHMARK=false -DWITH_GUDHI_EXAMPLE=false -DWITH_GUDHI_PYTHON=true -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=false  -DWITH_GUDHI_GUDHUI=false -DWITH_GUDHI_REMOTE_TEST=false -DPython_ADDITIONAL_VERSIONS=$$py3ver -DWITH_GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS=false -DHERA_INCLUDE_DIR=/usr/include ; \
	done

override_dh_auto_build-arch:
	dh_auto_build $(DHFLAGS) --sourcedir=build/userversion --builddirectory=build/userversion/build
	for py3ver in $(PY3VERS) ; do \
		cd build-py$$py3ver/userversion/build/python ; \
		/usr/bin/python$$py3ver setup.py build ; \
	done

override_dh_auto_build-indep:
	cd build/userversion/build ; \
	make doxygen
	find build/userversion/build/html -type f -iname '*.html' -exec sh -c "sed -i 's/.*polyfill\.io.*//g' {}" \;

override_dh_auto_test-indep:

override_dh_auto_test-arch:
# I believe this should be handled automatically by dh_auto_test,
# but see #901678.
ifeq (, $(filter nocheck,$(DEB_BUILD_MAINT_OPTIONS)))
	dh_auto_test $(DHFLAGS) --no-parallel --sourcedir=build/userversion --builddirectory=build/userversion/build
else
	@echo "Skipping tests due to nocheck flag."
endif

override_dh_auto_install-arch:
	dh_auto_install $(DHFLAGS) --sourcedir=build/userversion --builddirectory=build/userversion/build
	for py3ver in $(PY3VERS) ; do \
		cd build-py$$py3ver/userversion/build/python ; \
		/usr/bin/python$$py3ver setup.py install --root=../../../../debian/tmp --single-version-externally-managed --install-layout=deb ; \
	done

	mv $(TMPBIN)/Nerve \
	   $(TMPBIN)/gudhi-nerve
	mv $(TMPBIN)/VoronoiGIC \
	   $(TMPBIN)/gudhi-voronoi-gic
	mv $(TMPBIN)/Witness_complex_strong_witness_persistence \
	   $(TMPBIN)/gudhi-witness-complex-strong-witness-persistence
	mv $(TMPBIN)/Witness_complex_weak_witness_persistence \
	   $(TMPBIN)/gudhi-witness-complex-weak-witness-persistence
	mv $(TMPBIN)/alpha_complex_3d_persistence \
	   $(TMPBIN)/gudhi-alpha-complex-3d-persistence
	mv $(TMPBIN)/alpha_complex_persistence \
	   $(TMPBIN)/gudhi-alpha-complex-persistence
	mv $(TMPBIN)/bottleneck_distance \
	   $(TMPBIN)/gudhi-bottleneck-distance
	mv $(TMPBIN)/cech_persistence \
	   $(TMPBIN)/gudhi-cech-persistence
	mv $(TMPBIN)/cubical_complex_persistence \
	   $(TMPBIN)/gudhi-cubical-complex-persistence
	mv $(TMPBIN)/off_file_from_shape_generator \
	   $(TMPBIN)/gudhi-off-file-from-shape-generator
	mv $(TMPBIN)/periodic_cubical_complex_persistence \
	   $(TMPBIN)/gudhi-periodic-cubical-complex-persistence
	mv $(TMPBIN)/rips_correlation_matrix_persistence \
	   $(TMPBIN)/gudhi-rips-correlation-matrix-persistence
	mv $(TMPBIN)/rips_distance_matrix_persistence \
	   $(TMPBIN)/gudhi-rips-distance-matrix-persistence
	mv $(TMPBIN)/rips_persistence \
	   $(TMPBIN)/gudhi-rips-persistence
	mv $(TMPBIN)/sparse_rips_persistence \
	   $(TMPBIN)/gudhi-sparse-rips-persistence
	mv $(TMPBIN)/distance_matrix_edge_collapse_rips_persistence \
	   $(TMPBIN)/gudhi-distance-matrix-edge-collapse-rips-persistence
	mv $(TMPBIN)/point_cloud_edge_collapse_rips_persistence \
	   $(TMPBIN)/gudhi-point-cloud-edge-collapse-rips-persistence

	mv $(TMPBIN)/GudhUI $(TMPBIN)/gudhui

override_dh_auto_install-indep:
	find src -type f -path '*/example/*' \( -name '*.cpp' -o \( -name '*.txt' -a ! -iname 'cmake*' \) \) -exec sh -c 'name=$$(echo $$0 | sed s/src\\/// | sed s/example\\///); install -D -m 644 $$0 debian/tmp/usr/share/doc/libgudhi-examples/$$name' {} \;

override_dh_compress:
	dh_compress -X.cpp

override_dh_install:
	dh_install -X__pycache__ -X.pyc -X.pyo

override_dh_missing:
	dh_missing --list-missing

override_dh_python3:
	for py3ver in $(PY3VERS) ; do \
		dh_python3 -O--sourcedir=build-py$$py3ver/userversion ; \
	done

execute_before_dh_auto_clean:
	rm -rf build
	for py3ver in $(PY3VERS) ; do \
		rm -rf build-py$$py3ver ; \
	done
